/*
 * tmos - iram_alloc.h
 *
 * IRAM memory allocator
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_IRAM_ALLOC_H
#define __ASM_IRAM_ALLOC_H

#include <tmos/config.h>

#define iram_lock() local_irq_disable()
#define iram_unlock() local_irq_enable()

typedef void __data *iram_ptr;
typedef unsigned char iram_size_t;

iram_ptr iram_alloc(iram_size_t size);
iram_ptr __iram_alloc(iram_size_t size);
void __iram_free(iram_size_t size);

#endif
