/*
 * tmos - jiffies.h
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __JIFFIES_H
#define __JIFFIES_H

#include <asm/jiffies.h>
#include <asm/param.h>

#ifndef time_after
#define time_after(a, b)	((sjiffies_t)(b) - (sjiffies_t)(a) < 0)
#endif

#ifndef time_after_eq
#define time_after_eq(a, b)	((sjiffies_t)(a) - (sjiffies_t)(b) >= 0)
#endif

#define US_JIFFIES(x)	(((unsigned long)(x) * HZ + 999999UL) / 1000000UL)
#define MS_JIFFIES(x)	(((unsigned long)(x) * HZ + 999UL) / 1000UL)
#define S_JIFFIES(x)	((unsigned long)(x) * HZ)

#define us_jiffies(x)	((unsigned long)(x) / (1000000UL / HZ))
#define s_jiffies(x)	((unsigned long)(x) * HZ)

#define jiffies_ms(x)	((unsigned long)(x) * 1000UL / HZ)

#define usleep(x)	jsleep(US_JIFFIES(x))
#define msleep(x)	jsleep(MS_JIFFIES(x))
#define sleep(x)	jsleep(S_JIFFIES(x))

#endif
