/*
 * tmos - string.h
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TMOS_STRING_H
#define __TMOS_STRING_H

#include <tmos/config.h>

#define strcmp(a, b) \
	tmos_strcmp((const char *__force) (a), (const char *__force) (b))
#define strlen(s) tmos_strlen((const char *__force) (s))
#define memcpy(dst, src, n) \
	tmos_memcpy((void *__force)(dst), (void *__force)(src), (n))

extern int tmos_strcmp(const char *asrc, const char *adst) __reentrant;
int tmos_strlen(const char *str) __reentrant;

void tmos_memcpy(void *dst, const void *src, unsigned char n) __reentrant;

void memset_kernel(void __kernel *_dst, unsigned char c, unsigned char n)
	__reentrant;
void memset_highmem(void __highmem *_dst, unsigned char c, unsigned char n)
	__reentrant;

#endif
