/*
 * data2header - convert data to C header
 *
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <stdio.h>

int main(void)
{
	int c;
	unsigned int i = 0;
	unsigned int line = 0;

	while (!feof(stdin)) {
		c = fgetc(stdin);

		if (c == EOF)
			break;
		if (i == 0) {
			putc('\t', stdout);
		}
		if (i == 8) {
			putc(' ', stdout);
		}

		printf("0x%02x, ", c);

		i++;
		if (i == 16) {
			i = 0;
			printf("/* 0x%03x0 */", line);
			line++;
		}
	}
	if (i)
		printf("\n");
	return 0;
}
